unit U_GetDllForm;

interface

uses
  Windows, Messages, forms, OleCtnrs, DateUtils, SysUtils, ADODB, dxCore,
  ActiveX;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd; export; stdcall;

function ConnData(): Boolean;

implementation

uses
  U_DataLink, U_SxXnKcList, U_CPTopList, U_KHTopList, U_YarnReport,
  U_MaterielReport, U_FSYarnReport, U_JTYarnReport, U_PBKcAllList, U_JYCLTJ,
  U_ClothCLList;

       /////////////////////////////////////////////////////////////////
      //         功能说明:取Dll中得窗体                              //
     //        参数说明：App>>调用应用程序；                        //
    //                 FormH>>调用窗口句柄 ；                      //
   //                 FormID>>窗口号;                             //
  //                 Language>>语言种类;                         //
 //                 WinStyle>>窗口类型；                        //
/////////////////////////////////////////////////////////////////
var
  frmSxXnKcList: TfrmSxXnKcList;

function GetDllForm(App: Tapplication; FormH: hwnd; FormID: integer; Language: integer; WinStyle: integer; GCode: Pchar; GName: Pchar; DataBase: Pchar; Title: PChar; Parameters1: PChar; Parameters2: PChar; Parameters3: PChar; Parameters4: PChar; Parameters5: PChar; Parameters6: PChar; Parameters7: PChar; Parameters8: PChar; Parameters9: PChar; Parameters10: PChar; DataBaseStr: PChar): hwnd;
var
  i: Integer;
  bFound: Boolean;
  mnewHandle: hwnd;
  mstyle: TFormStyle;     // 0:子窗口; 1：普通窗口
  mstate: TWindowState;
  mborderstyle: TFormBorderStyle;
begin
  mnewHandle := 0;
  DName := PChar(GName);
  DCode := PChar(GCode);
  DdataBase := DataBase;
  DTitCaption := Title;
  DParameters1 := Parameters1;
  DParameters2 := Parameters2;
  DParameters3 := Parameters3;
  DParameters4 := Parameters4;
  DParameters5 := Parameters5;
  DParameters6 := Parameters6;
  DParameters7 := Parameters7;
  DParameters8 := Parameters8;
  DParameters9 := Parameters9;
  DParameters10 := Parameters10;

  MainApplication := App;
  DCurHandle := FormH;
  IsDelphiLanguage := Language;

  Application := TApplication(App);
  DCurHandle := 0;


   //赋值链接字符串
  SetLength(server, 255);
  SetLength(dtbase, 255);
  SetLength(user, 255);
  SetLength(pswd, 255);

  server := '101.132.143.144,7781';
  dtbase := 'yichengluowendata';
  user := 'rtsa';
  pswd := 'rightsoft@5740';
  DConString := 'Provider=SQLOLEDB.1;Password=' + pswd + ';Persist Security Info=True;User ID=' + user + ';Initial Catalog=' + dtbase + ';Data Source=' + server;
  DConString := DataBaseStr;

  if not ConnData() then
  begin
    result := 0;
    exit;
  end;

   // 定义窗口类型 、状态
  if WinStyle = 0 then
  begin
    mstyle := fsMDIChild;
    mstate := wsMaximized;
    mborderstyle := bsSizeable;
  end
  else
  begin
    mstyle := fsNormal;
    mstate := wsNormal;
    mborderstyle := bsSizeable;
  end;
  /////////////////////
  //调用子模块窗口
  case FormID of
    111:  //客户销量排行榜
      begin
        if frmKHTopList = nil then
        begin
          frmKHTopList := TfrmKHTopList.Create(application.MainForm);
          with frmKHTopList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmKHTopList.BringToFront;
       //句柄
        mnewHandle := frmKHTopList.Handle;
      end;
    121:  //产品销量排行榜
      begin
        if frmCPTopList = nil then
        begin
          frmCPTopList := TfrmCPTopList.Create(application.MainForm);
          with frmCPTopList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmCPTopList.BringToFront;
       //句柄
        mnewHandle := frmCPTopList.Handle;
      end;

    131:  //纱线月报表
      begin
        if frmYarnReport = nil then
        begin
          frmYarnReport := TfrmYarnReport.Create(application.MainForm);
          with frmYarnReport do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmYarnReport.BringToFront;
       //句柄
        mnewHandle := frmYarnReport.Handle;
      end;
    132:  //纺丝纱线月报表
      begin
        if frmFSYarnReport = nil then
        begin
          frmFSYarnReport := TfrmFSYarnReport.Create(application.MainForm);
          with frmFSYarnReport do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmFSYarnReport.BringToFront;
       //句柄
        mnewHandle := frmFSYarnReport.Handle;
      end;

    133:  //加弹月报表
      begin
        if frmJTYarnReport = nil then
        begin
          frmJTYarnReport := TfrmJTYarnReport.Create(application.MainForm);
          with frmJTYarnReport do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJTYarnReport.BringToFront;
       //句柄
        mnewHandle := frmJTYarnReport.Handle;
      end;
    141:  //机物料月报表
      begin
        if frmMaterielReport = nil then
        begin
          frmMaterielReport := TfrmMaterielReport.Create(application.MainForm);
          with frmMaterielReport do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmMaterielReport.BringToFront;
       //句柄
        mnewHandle := frmMaterielReport.Handle;
      end;

    151:  //坯布汇总库存统计
      begin
        if frmPBKcAllList = nil then
        begin
          frmPBKcAllList := TfrmPBKcAllList.Create(application.MainForm);
          with frmPBKcAllList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmPBKcAllList.BringToFront;
       //句柄
        mnewHandle := frmPBKcAllList.Handle;
      end;

    161:  //检验产量统计
      begin
        if frmJYCLTJ = nil then
        begin
          frmJYCLTJ := TfrmJYCLTJ.Create(application.MainForm);
          with frmJYCLTJ do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmJYCLTJ.BringToFront;
       //句柄
        mnewHandle := frmJYCLTJ.Handle;
      end;

    171:  //机台产量明细
      begin
        if frmClothCLList = nil then
        begin
          frmClothCLList := TfrmClothCLList.Create(application.MainForm);
          with frmClothCLList do
          begin
            caption := Trim(Title);
            FormStyle := mstyle;
            windowState := mstate;
            BorderStyle := mborderstyle;
           //show;
          end;
        end
        else
          frmClothCLList.BringToFront;
       //句柄
        mnewHandle := frmClothCLList.Handle;
      end;
  end;

  Result := mnewHandle;
//  NewDllApp := Application;
end;
//===========================================================
  //建立数据库连接池
//===========================================================

function ConnData(): Boolean;
begin
  if not Assigned(DataLink_Statistics) then
    DataLink_Statistics := TDataLink_Statistics.Create(Application);
  try
    with DataLink_Statistics.ADOLink do
    begin
      //if not Connected then
      begin
        Connected := false;
        ConnectionString := DConString;
        LoginPrompt := false;
        Connected := true;
      end;
    end;
    Result := true;
  except
    Result := false;
    application.MessageBox('数据库连接失败！', '错误', mb_Ok + MB_ICONERROR);
  end;

end;

//initialization
//  OldDllApp := Application;
//
//
//finalization
//  DataLink_Statistics.Free;
//  Application := OldDllApp;

initialization
  CoInitialize(nil);
  dxUnitsLoader.Initialize;


finalization
  DataLink_Statistics.Free;
  application := NewDllApp;
  dxUnitsLoader.Finalize;

end.

